#define PLUGIN_VERSION    "1.0.2"
#define PLUGIN_NAME       "L4D2 镭射瞄准"

#include <sourcemod>

static Handle:cvarDelay							= INVALID_HANDLE;

static bool:bHasLaser[MAXPLAYERS+1]				= false;
static Float:fLastCommandUseTime[MAXPLAYERS+1]	= 0.0;

public Plugin:myinfo =
{
	name = PLUGIN_NAME,
	author = "AtomicStryker汉化者:心动",
	description = "L4D2 Laser Sights",
	version = PLUGIN_VERSION,
	url = "http://forums.alliedmods.net/showthread.php?p=877908"
};

public OnPluginStart()
{
	CreateConVar("l4d2_lasersight_version", PLUGIN_VERSION, "插件版本", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_NOTIFY|FCVAR_DONTRECORD);
	cvarDelay = CreateConVar("l4d2_lasersight_delay", "0", " 冷却时间 ", FCVAR_PLUGIN|FCVAR_NOTIFY);
	
	RegConsoleCmd("sm_laseron", CmdLaserOn);                      //激活红外线
	RegConsoleCmd("sm_laseroff", CmdLaserOff);                    //关闭红外线
	RegConsoleCmd("sm_laser", CmdLaserToggle);                    //可激活[关闭]或外线
}

public Action:CmdLaserOn(client, args)
{
	if (IsCommandCoolingDown(client))
	{
		ReplyToCommand(client, "你不能这么快激活红外线, 冷却时间 %i 秒", RoundFloat(GetConVarFloat(cvarDelay)));
		return Plugin_Handled;
	}
	
	CheatCommand(client, "upgrade_add", "LASER_SIGHT");
	bHasLaser[client] = true;
	fLastCommandUseTime[client] = GetEngineTime();
	
	return Plugin_Handled;
}

public Action:CmdLaserOff(client, args)
{
	if (IsCommandCoolingDown(client))
	{
		ReplyToCommand(client, "你不能这么快关闭红外线, 冷却时间 %i 秒", RoundFloat(GetConVarFloat(cvarDelay)));
		return Plugin_Handled;
	}

	CheatCommand(client, "upgrade_remove", "LASER_SIGHT");
	bHasLaser[client] = false;
	fLastCommandUseTime[client] = GetEngineTime();
	
	return Plugin_Handled;
}

public Action:CmdLaserToggle(client, args)
{
	if (IsCommandCoolingDown(client))
	{
		ReplyToCommand(client, "你不能这么快激活[关闭]红外线, 冷却时间 %i 秒", RoundFloat(GetConVarFloat(cvarDelay)));
		return Plugin_Handled;
	}

	if (bHasLaser[client])
	{
		CheatCommand(client, "upgrade_remove", "LASER_SIGHT");
		bHasLaser[client] = false;
		fLastCommandUseTime[client] = GetEngineTime();
	}
	else
	{
		CheatCommand(client, "upgrade_add", "LASER_SIGHT");
		bHasLaser[client] = true;
		fLastCommandUseTime[client] = GetEngineTime();
	}
	fLastCommandUseTime[client] = GetEngineTime();
	
	return Plugin_Handled;
}

static bool:IsCommandCoolingDown(any:client)
{
	if (fLastCommandUseTime[client] == 0.0) 
	{
		return false;
	}
	return ((GetEngineTime() - fLastCommandUseTime[client]) < GetConVarFloat(cvarDelay));
}

stock CheatCommand(client, const String:command[], const String:arguments[])
{
    if (!client) return;
    new admindata = GetUserFlagBits(client);
    SetUserFlagBits(client, ADMFLAG_ROOT);
    new flags = GetCommandFlags(command);
    SetCommandFlags(command, flags & ~FCVAR_CHEAT);
    FakeClientCommand(client, "%s %s", command, arguments);
    SetCommandFlags(command, flags);
    SetUserFlagBits(client, admindata);
}